/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import Page = require('../../../../../base/Page');
import Response = require('../../../../../http/response');
import Understand = require('../../../Understand');
import serialize = require('../../../../../base/serialize');
import { SerializableClass } from '../../../../../interfaces';

/**
 * @description Initialize the IntentActionsList
 * PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
 *
 * @param version - Version of the resource
 * @param assistantSid - The unique ID of the parent Assistant.
 * @param intentSid - The unique ID of the Intent.
 */
declare function IntentActionsList(version: Understand, assistantSid: string, intentSid: string): IntentActionsListInstance;

/**
 * Options to pass to update
 *
 * @property actions - The JSON actions that instruct the Assistant how to perform this task.
 */
interface IntentActionsInstanceUpdateOptions {
  actions?: string;
}

interface IntentActionsListInstance {
  /**
   * @param sid - sid of instance
   */
  (sid: string): IntentActionsContext;
  /**
   * Constructs a intent_actions
   */
  get(): IntentActionsContext;
}

interface IntentActionsPayload extends IntentActionsResource, Page.TwilioResponsePayload {
}

interface IntentActionsResource {
  account_sid: string;
  assistant_sid: string;
  data: string;
  intent_sid: string;
  url: string;
}

interface IntentActionsSolution {
  assistantSid?: string;
  intentSid?: string;
}


declare class IntentActionsContext {
  /**
   * Initialize the IntentActionsContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param assistantSid - The unique ID of the parent Assistant.
   * @param intentSid - The unique ID of the Intent.
   */
  constructor(version: Understand, assistantSid: string, intentSid: string);

  /**
   * fetch a IntentActionsInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: IntentActionsInstance) => any): Promise<IntentActionsInstance>;
  /**
   * update a IntentActionsInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  update(opts?: IntentActionsInstanceUpdateOptions, callback?: (error: Error | null, items: IntentActionsInstance) => any): Promise<IntentActionsInstance>;
}


declare class IntentActionsInstance extends SerializableClass {
  /**
   * Initialize the IntentActionsContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @property accountSid - The unique ID of the Account that created this Field.
   * @property assistantSid - The unique ID of the parent Assistant.
   * @property intentSid - The unique ID of the Intent.
   * @property url - The url
   * @property data - The data
   *
   * @param version - Version of the resource
   * @param payload - The instance payload
   * @param assistantSid - The unique ID of the parent Assistant.
   * @param intentSid - The unique ID of the Intent.
   */
  constructor(version: Understand, payload: IntentActionsPayload, assistantSid: string, intentSid: string);

  private _proxy: IntentActionsContext;
  accountSid: string;
  assistantSid: string;
  data: string;
  /**
   * fetch a IntentActionsInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: IntentActionsInstance) => any): void;
  intentSid: string;
  /**
   * Produce a plain JSON object version of the IntentActionsInstance for serialization.
   * Removes any circular references in the object.
   */
  toJSON(): any;
  /**
   * update a IntentActionsInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  update(opts?: IntentActionsInstanceUpdateOptions, callback?: (error: Error | null, items: IntentActionsInstance) => any): void;
  url: string;
}


declare class IntentActionsPage extends Page<Understand, IntentActionsPayload, IntentActionsResource, IntentActionsInstance> {
  /**
   * Initialize the IntentActionsPagePLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param response - Response from the API
   * @param solution - Path solution
   */
  constructor(version: Understand, response: Response<string>, solution: IntentActionsSolution);

  /**
   * Build an instance of IntentActionsInstance
   *
   * @param payload - Payload response from the API
   */
  getInstance(payload: IntentActionsPayload): IntentActionsInstance;
}

export { IntentActionsContext, IntentActionsInstance, IntentActionsList, IntentActionsListInstance, IntentActionsPage, IntentActionsPayload, IntentActionsResource, IntentActionsSolution }
