/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import Page = require('../../../../../base/Page');
import Response = require('../../../../../http/response');
import Understand = require('../../../Understand');
import { SerializableClass } from '../../../../../interfaces';

/**
 * @description Initialize the IntentStatisticsList
 * PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
 *
 * @param version - Version of the resource
 * @param assistantSid - The unique ID of the parent Assistant.
 * @param intentSid - The unique ID of the Intent associated with this Field.
 */
declare function IntentStatisticsList(version: Understand, assistantSid: string, intentSid: string): IntentStatisticsListInstance;

interface IntentStatisticsListInstance {
  /**
   * @param sid - sid of instance
   */
  (sid: string): IntentStatisticsContext;
  /**
   * Constructs a intent_statistics
   */
  get(): IntentStatisticsContext;
}

interface IntentStatisticsPayload extends IntentStatisticsResource, Page.TwilioResponsePayload {
}

interface IntentStatisticsResource {
  account_sid: string;
  assistant_sid: string;
  fields_count: number;
  intent_sid: string;
  samples_count: number;
  url: string;
}

interface IntentStatisticsSolution {
  assistantSid?: string;
  intentSid?: string;
}


declare class IntentStatisticsContext {
  /**
   * Initialize the IntentStatisticsContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param assistantSid - The assistant_sid
   * @param intentSid - The intent_sid
   */
  constructor(version: Understand, assistantSid: string, intentSid: string);

  /**
   * fetch a IntentStatisticsInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: IntentStatisticsInstance) => any): Promise<IntentStatisticsInstance>;
}


declare class IntentStatisticsInstance extends SerializableClass {
  /**
   * Initialize the IntentStatisticsContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @property accountSid - The unique ID of the Account that created this Field.
   * @property assistantSid - The unique ID of the parent Assistant.
   * @property intentSid - The unique ID of the Intent associated with this Field.
   * @property samplesCount - The total number of Samples associated with this Intent.
   * @property fieldsCount - The total number of Fields associated with this Intent.
   * @property url - The url
   *
   * @param version - Version of the resource
   * @param payload - The instance payload
   * @param assistantSid - The unique ID of the parent Assistant.
   * @param intentSid - The unique ID of the Intent associated with this Field.
   */
  constructor(version: Understand, payload: IntentStatisticsPayload, assistantSid: string, intentSid: string);

  private _proxy: IntentStatisticsContext;
  accountSid: string;
  assistantSid: string;
  /**
   * fetch a IntentStatisticsInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: IntentStatisticsInstance) => any): void;
  fieldsCount: number;
  intentSid: string;
  samplesCount: number;
  /**
   * Produce a plain JSON object version of the IntentStatisticsInstance for serialization.
   * Removes any circular references in the object.
   */
  toJSON(): any;
  url: string;
}


declare class IntentStatisticsPage extends Page<Understand, IntentStatisticsPayload, IntentStatisticsResource, IntentStatisticsInstance> {
  /**
   * Initialize the IntentStatisticsPagePLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param response - Response from the API
   * @param solution - Path solution
   */
  constructor(version: Understand, response: Response<string>, solution: IntentStatisticsSolution);

  /**
   * Build an instance of IntentStatisticsInstance
   *
   * @param payload - Payload response from the API
   */
  getInstance(payload: IntentStatisticsPayload): IntentStatisticsInstance;
}

export { IntentStatisticsContext, IntentStatisticsInstance, IntentStatisticsList, IntentStatisticsListInstance, IntentStatisticsPage, IntentStatisticsPayload, IntentStatisticsResource, IntentStatisticsSolution }
